// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import static net.cellcomputing.himawari.library.EqModeBlock.*;

/**
 * 
 *  Define the context that exists between calls to RiFrameBegin/RiFrameEnd.
 *  RiFrameBegin/RiFrameEndの呼び出されている間に存在する、コンテキストを定義する。			
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqFrameModeBlock extends CqModeBlock
{
	/**
	 * コンストラクタ。　初期値の設定。
	 * @param	pconParent	前のコンテキスト
	 */
	public CqFrameModeBlock( final  CqModeBlock pconParent )
	{
		super( pconParent, Frame);
		m_optCurrent = pconParent.optCurrent();
		
	    // Create new Attributes as they must be pushed/popped by the state change.
		//　状態の変化で変わるアトリビュートを新しく作成。
	    m_pattrCurrent = new CqAttributes( pconParent.m_pattrCurrent );
	    m_pattrCurrent.AddRef();
		m_ptransCurrent = new CqTransform(pconParent.m_ptransCurrent );
	}

	/**
	 * デストラクタ。
	 * 参照を削除。 (参照カウンタをデクリメント) 
	 */
	@Override
	public void destruct()
	{
		m_pattrCurrent.Release();		
	}
	
	
	/**
	 * Create a main context.<br>
	 * 	メインのコンテキストを作成する。
	 * 
	 * @warning フレームコンテキストの中で、このメソッドが呼ばれた場合エラーとなる。
	 */
	@Override
	public CqModeBlock	BeginMainModeBlock()
	{
		return 	null;	// Error
	}	
	
	/** 
	 * Create a frame context.<br>
	 * 	フレームのコンテキストを作成する。
	 * 
	 * @warning フレームコンテキストの中で、このメソッドが呼ばれた場合エラーとなる。
	 */	
	@Override
	public CqModeBlock	BeginFrameModeBlock()
  	{
		return  null;	// Error
  	}	
	
	/** 
	 * Create a solid context.<br>
	 * 	ソリッドのコンテキストを作成する。
	 * 
	 * @warning フレームコンテキストの中で、このメソッドが呼ばれた場合エラーとなる。
	 */
	@Override
	public CqModeBlock	BeginSolidModeBlock( String type )
	{
		return  null;	// Error
	}	

	/** 
	 * Delete the frame context.<br>
	 * 　フレームのコンテキストを消去。
	 * 
	 * @attention 	このメソッドのみ、フレームのコンテキストを消去することができる。
	 */
	@Override
	public 	void	EndFrameModeBlock()
	{
		destruct(); 
	}

	/** 
	 * Get a reference to the currently stored options.<br>
	 * 　現在の保存されているオプションゲッタ。
	 * 
	 * @return	 現在のオプション
	 */
	@Override
	public  CqOptions optCurrent()
	{
		return ( m_optCurrent );
	}

	private	CqOptions m_optCurrent = new CqOptions();	///< 現在のグラフィックス環境オプション。	Current graphics environment components
}

